package lcsb.mapviewer.persist.dao;

import java.util.Calendar;
import java.util.List;

import javax.persistence.TemporalType;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Repository;

import lcsb.mapviewer.model.Stacktrace;

@Repository
public class StacktraceDao extends BaseDao<Stacktrace> {

  @SuppressWarnings("unused")
  private static Logger logger = LogManager.getLogger();

  public StacktraceDao() {
    super(Stacktrace.class);
  }

  @Override
  public Stacktrace getById(final Integer id) {
    return getById(id + "");
  }

  public Stacktrace getById(final String id) {
    if (id == null) {
      return null;
    }
    List<?> list = getSession()
        .createQuery(" from " + this.getClazz().getSimpleName() + " where id=:id " + removableAndStatemant())
        .setParameter("id", id).list();
    if (list.size() == 0) {
      return null;
    } else {
      return (Stacktrace) list.get(0);
    }
  }

  public void removeBeforeDate(final Calendar cleanupTimestamp) {
    getSession().createQuery("delete from " + this.getClazz().getSimpleName() + " where createdAt < :cleanupTimestamp ")
        .setParameter("cleanupTimestamp", cleanupTimestamp, TemporalType.TIMESTAMP)
        .executeUpdate();
  }

  public void removeOld() {
    Calendar cleanupTimestamp = Calendar.getInstance();
    cleanupTimestamp.add(Calendar.MINUTE, -10); // remove everything except the last 10 minutes

    removeBeforeDate(cleanupTimestamp);
  }

}
